function Chart(el){this._cont=el;this._yMin=null;this._yMax=null;this._xGridDensity=0;this._yGridDensity=0;this._flags=0;this._series=new Array();this._labelPrecision=0;this._horizontalLabels=new Array();this._barWidth=10;this._barDistance=2;this._bars=0;this._showLegend=true;this._painter=null;if((typeof CanvasChartPainterFactory!='undefined')&&(window.CanvasRenderingContext2D)){this.setPainterFactory(CanvasChartPainterFactory);}
else if(typeof JsGraphicsChartPainterFactory!='undefined'){this.setPainterFactory(JsGraphicsChartPainterFactory);}
else{this._painterFactory=null;}}
Chart.prototype.setPainterFactory=function(f){this._painterFactory=f;this._painter=this._painterFactory();this._painter.create(this._cont);};Chart.prototype.getPainter=function(){return this._painter;};Chart.prototype.setVerticalRange=function(min,max){this._yMin=min;this._yMax=max;};Chart.prototype.setLabelPrecision=function(precision){this._labelPrecision=precision;};Chart.prototype.setShowLegend=function(b){this._showLegend=b;};Chart.prototype.setGridDensity=function(horizontal,vertical){this._xGridDensity=horizontal;this._yGridDensity=vertical;};Chart.prototype.setHorizontalLabels=function(labels){this._horizontalLabels=labels;};Chart.prototype.add=function(series){this._series.push(series);};Chart.prototype.draw=function(){var i,o,o2,len,xlen,ymin,ymax,type,self,bLabels;if(!this._painter){return;}
this.xlen=0;this.ymin=this._yMin;this.ymax=this._yMax;for(i=0;i<this._series.length;i++){this._series[i].setRange(this);}
this.xlen++;this._xGridDensity++;bLabels=(this._xGridDensity)&&(this._yGridDensity);this.init(this.xlen,this.ymin,this.ymax,this._xGridDensity,this._yGridDensity,bLabels);this.drawBackground();if(this._showLegend){this.drawLegend();}
if(bLabels){this.drawVerticalAxis(this._yGridDensity,this._labelPrecision);this.drawHorizontalAxis(this.xlen,this._horizontalLabels,this._xGridDensity,this._labelPrecision);}
this.drawGrid();for(i=0;i<this._series.length;i++){this._series[i].draw(this);}
this.drawAxis();};Chart.prototype.init=function(xlen,ymin,ymax,xgd,ygd,bLegendLabels){this.w=this._painter.getWidth();this.h=this._painter.getHeight();this.chartx=0;this.chartw=this.w;this.charth=this.h;this.charty=0;this.xlen=xlen;this.ymin=ymin;this.ymax=ymax;this.xgd=xgd;this.ygd=ygd;this.calc(this.chartw,this.charth,xlen,ymin,ymax,xgd,ygd);};Chart.prototype.calc=function(w,h,xlen,ymin,ymax,xgd,ygd){this.range=ymax-ymin;this.xstep=w/(xlen-1);this.xgrid=(xgd)?w/(xgd-1):0;this.ygrid=(ygd)?h/(ygd-1):0;this.ymin=ymin;this.ymax=ymax;};Chart.prototype.findSeries=function(label){for(var i=0;i<this._series.length;i++){if(this._series[i].getLabel()==label){return this._series[i];}}
return null;};Chart.prototype.drawLegend=function(){var legend,list,item,label;var series=this._series;legend=document.createElement('div');legend.className='legend';legend.style.position='absolute';list=document.createElement('ul');for(i=0;i<series.length;i++){item=document.createElement('li');item.style.color=series[i].getColor();label=document.createElement('span');label.appendChild(document.createTextNode(series[i].getLabel()));label.style.color='black';item.appendChild(label);list.appendChild(item);}
legend.appendChild(list);this._cont.appendChild(legend);legend.style.right='0px';legend.style.top=this.charty+(this.charth/2)-(legend.offsetHeight/2)+'px';this.legend=legend;this.chartw=this.w-(this.legend.offsetWidth+5);this.calc(this.chartw,this.charth,this.xlen,this.ymin,this.ymax,this.xgd,this.ygd);};Chart.prototype.drawVerticalAxis=function(ygd,precision){var axis,item,step,y,ty,n,yoffset,value,multiplier,w,items,pos;multiplier=Math.pow(10,precision);step=this.range/(ygd-1);axis=document.createElement('div');axis.style.position='absolute';axis.style.left='0px';axis.style.top='0px';axis.style.textAlign='right';this._cont.appendChild(axis);w=0;items=new Array();for(n=0,i=this.ymax;(i>this.ymin)&&(n<ygd-1);i-=step,n++){item=document.createElement('span');value=parseInt(i*multiplier)/multiplier;item.appendChild(document.createTextNode(value));axis.appendChild(item);items.push([i,item]);if(item.offsetWidth>w){w=item.offsetWidth;}}
item=document.createElement('span');item.appendChild(document.createTextNode(this.ymin));axis.appendChild(item);items.push([this.ymin,item]);if(item.offsetWidth>w){w=item.offsetWidth;}
axis.style.width=w+'px';this.chartx=w+5;this.charty=item.offsetHeight/2;this.charth=this.h-((item.offsetHeight*1.5)+5);this.chartw=this.w-(((this.legend)?this.legend.offsetWidth:0)+w+10);this.calc(this.chartw,this.charth,this.xlen,this.ymin,this.ymax,this.xgd,this.ygd);n=this.range/this.charth;yoffset=(this.ymin/n);for(i=0;i<items.length;i++){item=items[i][1];pos=items[i][0];if(pos==this.ymin){y=this.charty+this.charth-1;}
else{y=this.charty+(this.charth-(pos/n)+yoffset);}
this._painter.fillRect('black',this.chartx-5,y,5,1);ty=y-(item.offsetHeight/2);item.style.position='absolute';item.style.right='0px';item.style.top=ty+'px';}};Chart.prototype.drawHorizontalAxis=function(xlen,labels,xgd,precision){var axis,item,step,x,tx,n,multiplier;multiplier=Math.pow(10,precision);n=this.chartw/(xgd-1);axis=document.createElement('div');axis.style.position='absolute';axis.style.left='0px';axis.style.top=(this.charty+this.charth+5)+'px';axis.style.width=this.w+'px';this._cont.appendChild(axis);for(i=0;i<xgd;i++){item=document.createElement('span');if(labels[i]){item.appendChild(document.createTextNode(labels[i]));}
axis.appendChild(item);x=this.chartx+(n*i);tx=x-(item.offsetWidth/2);item.style.position='absolute';item.style.left=tx+'px';item.style.top='0px';this._painter.fillRect('black',x,this.charty+this.charth,1,5);}};Chart.prototype.drawAxis=function(){var x1,x2,y1,y2;x1=this.chartx;x2=this.chartx+this.chartw+1;y1=this.charty;y2=this.charty+this.charth-1;this._painter.line('black',1,x1,y1,x1,y2);this._painter.line('black',1,x1,y2,x2,y2);};Chart.prototype.drawBackground=function(){this._painter.fillRect('white',0,0,this.w,this.h);};Chart.prototype.drawGrid=function(){if(this.xgrid){for(i=this.xgrid;i<this.chartw;i+=this.xgrid){this._painter.line('silver',1,this.chartx+i,this.charty,this.chartx+i,this.charty+this.charth-1);}}
if(this.ygrid){for(i=this.charth-this.ygrid;i>0;i-=this.ygrid){this._painter.line('silver',1,this.chartx+1,this.charty+i,this.chartx+this.chartw+1,this.charty+i);}}};function AbstractChartSeries(){}
AbstractChartSeries.prototype.getColor=function(){return this.data['color'];};AbstractChartSeries.prototype.getLabel=function(){return this.data['label'];};AbstractChartSeries.prototype.setRange=function(chart){if(this.data['values'].length>chart.xlen){chart.xlen=this.data['values'].length;}
for(var j=0;j<this.data['values'].length;j++){if((this.data['values'][j]<chart.ymin)||(chart.ymin==null)){chart.ymin=this.data['values'][j];}
if(this.data['values'][j]>chart.ymax){chart.ymax=this.data['values'][j];}}};AbstractChartSeries.prototype.getStackedValues=function(chart){var stacked=new Array();if(this.data['stackedOn']){var stackedSeries=chart.findSeries(this.data['stackedOn']);if(stackedSeries){stacked=stackedSeries.getStackedValues(chart);}}
for(var i=0;i<this.data['values'].length;i++){if(stacked[i]){stacked[i]+=this.data['values'][i];}else{stacked[i]=this.data['values'][i];}}
return stacked;};AbstractChartSeries.prototype.setConfig=function(name,value){if(!value&&typeof name==Object){this.data=name;}else{this.data[name]=value;}};AbstractChartSeries.prototype.getConfig=function(){if(name){return this.data[name];}else{return this.data;}};function BarChartSeries(data){var defaultData={label:"BarChart",color:"#000",values:[],distance:0,width:10,offset:0,};for(var p in data){defaultData[p]=data[p];}
this.data=defaultData;this.base=AbstractChartSeries;this.offset=this.data['distance']+this.data['offset']*(this.data['width']+this.data['distance']);}
BarChartSeries.prototype=new AbstractChartSeries;BarChartSeries.prototype.draw=function(chart){var i,len,x,y,barHt,yBottom,n,yoffset,painter,values;painter=chart.getPainter();values=this.getStackedValues(chart);if(values.length<=0)return;n=chart.range/chart.charth;yoffset=(chart.ymin/n);yBottom=chart.charty+chart.charth+yoffset;len=values.length;if(len>chart.xlen){len=chart.xlen;}
if(len){x=chart.chartx+this.offset+1;for(i=0;i<len;i++){y=(values[i]/n);barHt=(this.data['values'][i]/n);painter.fillRect(this.data['color'],x,yBottom-y,this.data['width'],barHt);x+=chart.xstep;}}};function AreaChartSeries(data){var defaultData={label:"AreaChart",color:"#000",values:[],};for(var p in data){defaultData[p]=data[p];}
this.data=defaultData;this.base=AbstractChartSeries;}
AreaChartSeries.prototype=new AbstractChartSeries;AreaChartSeries.prototype.draw=function(chart){var i,len,x,y,barHt,yBottom,n,yoffset,painter,values;var points=[];painter=chart.getPainter();values=this.getStackedValues(chart);if(values.length<=0)return;n=chart.range/chart.charth;yoffset=(chart.ymin/n);yBottom=chart.charty+chart.charth+yoffset;points.push({x:chart.chartx+1,y:chart.charty+chart.charth-1});len=values.length;if(len>chart.xlen){len=chart.xlen;}
if(len){for(i=0;i<len;i++){y=(values[i]/n);barHt=(this.data['values'][i]/n);points.push({x:chart.chartx+1+chart.xstep*i,y:yBottom-y});}
points.push({x:chart.chartx+1+chart.xstep*(len-1),y:chart.charty+chart.charth-1});for(i=len-1;i>=0;i--){y=(values[i]/n);barHt=(this.data['values'][i]/n);points.push({x:chart.chartx+1+chart.xstep*i,y:yBottom-y+barHt});}
painter.fillArea(this.data['color'],points);}};function LineChartSeries(data){var defaultData={label:"LineChart",color:"#000",values:[],};for(var p in data){defaultData[p]=data[p];}
this.data=defaultData;this.base=AbstractChartSeries;}
LineChartSeries.prototype=new AbstractChartSeries;LineChartSeries.prototype.draw=function(chart){var i,len,x,y,n,yoffset;painter=chart.getPainter();values=this.getStackedValues(chart);if(values.length<=0)return;var points=[];n=chart.range/chart.charth;yoffset=(chart.ymin/n);for(i=0;i<values.length;i++){points.push({x:chart.chartx+1+i*chart.xstep,y:chart.charty+chart.charth-(values[i]/n)+yoffset});}
painter.polyLine(this.data['color'],1,points);};function AbstractChartPainter(){};AbstractChartPainter.prototype.create=function(el){};AbstractChartPainter.prototype.getWidth=function(){return this.w;};AbstractChartPainter.prototype.getHeight=function(){return this.h;};AbstractChartPainter.prototype.fillArea=function(color,points){};AbstractChartPainter.prototype.polyLine=function(color,lineWidth,points){};AbstractChartPainter.prototype.fillRect=function(color,x,y,width,height){};AbstractChartPainter.prototype.line=function(color,lineWidth,x1,y1,x2,y2){};